<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class PackageRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
         if (! Auth::check()) {
            return false;
        }
        if(Auth::user()->role == 'admin' )
        {
            return true;
        }

        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules = [
            'cost'=>'required',
            'img'=>'sometimes|required',
        ];
         foreach (languages() as $lang) {
            $lang_rules=[
                'package.'.$lang->local.'.name'=> 'sometimes|required',
                'package.'.$lang->local.'.description'=> 'sometimes|required',
            ];
            $rules= array_merge($rules, $lang_rules);
        }
        
        return $rules;
    }
     /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $package = metaFields('packages');
        $attributes=[
            'cost.required'=>__('packages.cost'),
            'img.sometimes'=>__('packages.img'),
        ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'package.'.$lang->local.'.name'=> $package->{'name_'.$lang->local} ?? __('packages.name'),
                'package.'.$lang->local.'.description'=> $package->{'description'.$lang->local} ?? __('packages.description'), 
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }

        return $attributes;
    }
    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}